Codeforces Round 895 (Div. 3) A ~ F

这篇具有很好参考价值的文章主要介绍了Codeforces Round 895 (Div. 3) A ~ F。希望对大家有所帮助。如果存在错误或未考虑完全的地方,请大家不吝赐教,您也可以点击"举报违法"按钮提交疑问。

Dashboard - Codeforces Round 895 (Div. 3) - Codeforces

A

问多少次能使a 和 b相等,就是abs(a - b) / 2除c向上取整,也就是abs(a - b)除2c向上取整。

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'

using namespace std;

typedef pair<int, int> PII;
typedef long long ll;

void solve()
{
	int a, b, c;
	cin >> a >> b >> c;
	a = abs(a - b), c *= 2;
	cout << (a + c - 1) / c << endl;
}

int main()
{
	IOS
	int _;
	cin >> _;
	while(_ --)
	{
		solve();
	}
	
	return 0;
}

真是一篇好阅读理解,读了好久

就是说陷阱会在踩到后经过s秒触发,触发后不能通过,最少往前走d + s / 2(向上取整)格子后就回不来了,把所有的d + s / 2比较取最小值然后减一就是答案。

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'

using namespace std;

typedef pair<int, int> PII;
typedef long long ll;

void solve()
{
	int n;
	cin >> n;
	int ans = 2e9;
	for(int i = 0; i < n; i ++)
	{
		int a, b;
		cin >> a >> b;
		a = a + (b + 1) / 2;
		ans = min(ans, a);
	}
	
	cout << ans - 1 << endl;
}

int main()
{
	IOS
	int _;
	cin >> _;
	while(_ --)
	{
		solve();
	}
	
	return 0;
}

 C

如果是>2的偶数的话,x - 2和x就是一组解

如果l == r且l是奇数的话,可以求l的因子,设因子为d,x - d 和 d 都可以被d整除,这样也可以求出一组解

之后注意一些边界条件就好了。

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'

using namespace std;

typedef pair<int, int> PII;
typedef long long ll;

void solve()
{
	int l, r;
	cin >> l >> r;
	if(r < 4)
	{
		cout << -1 << endl;
		return;
	}
	if(r % 2 && l == r)
	{
		for(int i = 2; i * i <= l; i ++)
		{
			if(l % i == 0)
			{
				cout << l - i << ' ' << i << endl;
				return;
			}
		}
		cout << -1 << endl;
		return;
	}
	if(r % 2)
	{
		cout << r - 3 << ' ' << 2 << endl;
	}
	else cout << r - 2 << ' ' << 2 << endl;
}

int main()
{
	IOS
	int _;
	cin >> _;
	while(_ --)
	{
		solve();
	}
	
	return 0;
}

 贪心。

设lcm为x和y的最大公倍数,lcm的倍数的位置有重合,先加后减等于零,在这里操作是没意义的。

加操作有意义的点的数量:n / x - n / lcm

减操作有意义的点的数量:n / y - n / lcm

加的话从n开始加,依次递减n-1、n-2这样

减的话从1开始加,依次递增2、3这样。

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'

using namespace std;

typedef pair<int, int> PII;
typedef long long ll;

void solve()
{
	ll n, x, y;
	cin >> n >> x >> y;
	ll gcd = __gcd(x, y);
	ll lcm = x * y / gcd;
	
	ll a = n / x - n / lcm, b = n / y - n / lcm;
	a = a * (2 * n - a + 1) / 2;
	b = b * (b + 1) / 2;
	cout << a - b << endl;
}

int main()
{
	IOS
	int _;
	cin >> _;
	while(_ --)
	{
		solve();
	}
	
	return 0;
}

E

 前缀和。

 做出这道题需要了解的两个性质:

1. x ^ x = 0;

2. 0 ^ x = x;

根据这两条性质我们就可以求出任意一段连续区间的异或和,使用前缀数组实现,用b[]表示

b[n]表示从第一项异或到第n项

b[r] ^ b[l - 1]就等于 b[l - 1] ^ b[l] ^ ... ^ b[r] ^ b[l - 1] = b[l] ^ ... ^ b[r];

 对于第一个操作,区间修改,如果一个数x的对应位置上的树为1,被修改后变成0,就相当于x没被启用,变成0了,就相当于异或x本身,

如果一个数x的对应位置上的树为0,被修改后变成1,就相当于x被启用了,变成了1,也相当于异或x本身。

先用一个ans计算出被启用的数的异或和,之后每进行一次区间修改就相当于异或一遍这个区间内的异或和,非常的easy。

然后第二个操作,如果是查1,直接输出ans就好了

如果是查2,输出前n项异或前缀和异或ans就好了

听说有人线段树过了,挺nb的,之后再学一学。

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'

using namespace std;

typedef pair<int, int> PII;
typedef long long ll;

const int N = 100010;

int a[N], b[N];

void solve()
{
	int n;
	cin >> n;
	for(int i = 1; i <= n; i ++)
	{
		cin >> a[i];
		b[i] = b[i - 1] ^ a[i]; 
	}
	string s;
	cin >> s;
	s = ' ' + s;
	
	int ans = 0;
	for(int i = 1; i <= n; i ++)
	{
		if(s[i] == '1')
		{
			ans ^= a[i];
		}
	}
	
	int Q;
	cin >> Q;
	while(Q --)
	{
		int op;
		cin >> op;
		if(op == 1)
		{
			int l, r;
			cin >> l >> r;
			int res = b[r] ^ b[l - 1];
			ans ^= res;
		}
		else
		{
			int x;
			cin >> x;
			if(x == 1)cout << ans << ' ';
			else cout << (b[n] ^ ans) << ' ';
		}
	}
	cout << endl;
}

int main()
{
	IOS
	int _;
	cin >> _;
	while(_ --)
	{
		solve();
	}
	
	return 0;
}

赛后学的线段树做法:

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'

using namespace std;

typedef pair<int, int> PII;
typedef long long ll;

const int N = 100010;

int n;
int a[N];
string s;
struct Node
{
	int l, r;
	int sum0, sum1;
	int f;
}tr[N * 4];

void pushup(int u)
{
	tr[u].sum0 = tr[u << 1].sum0 ^ tr[u << 1 | 1].sum0;
	tr[u].sum1 = tr[u << 1].sum1 ^ tr[u << 1 | 1].sum1;
}

void pushdown(int u)
{
	Node &root = tr[u], &left = tr[u << 1], &right = tr[u << 1 | 1];
	if(tr[u].f)
	{
		swap(left.sum0, left.sum1);
		swap(right.sum0, right.sum1);
		left.f ^= tr[u].f;
		right.f ^= tr[u].f;
		tr[u].f = 0;
	}
}

void build(int u, int l, int r)
{
	if(l == r)
	{
		if(s[l] == '0')tr[u] = {l, r, a[l], 0, 0};
		else tr[u] = {l, r, 0, a[l], 0};
	}
	else
	{
		tr[u] = {l, r, 0, 0, 0};
		int mid = l + r >> 1;
		build(u << 1, l, mid), build(u << 1 | 1, mid + 1, r);
		pushup(u);
	}
}

void modify(int u, int l, int r)
{
	if(tr[u].l >= l && tr[u].r <= r)
	{
		swap(tr[u].sum0, tr[u].sum1);
		tr[u].f ^= 1;
	}
	else
	{
		pushdown(u);
		int mid = tr[u].l + tr[u].r >> 1;
		if(l <= mid)modify(u << 1, l, r);
		if(r > mid)modify(u << 1 | 1, l, r);
		pushup(u);
	}
}

void solve()
{
	cin >> n;
	for(int i = 1; i <= n; i ++)cin >> a[i];
	cin >> s;
	s = ' ' + s;
	
	build(1, 1, n);
	
	int Q;
	cin >> Q;
	while(Q --)
	{
		int op;
		cin >> op;
		if(op == 1)
		{
			int l, r;
			cin >> l >> r;
			modify(1, l, r);
		}
		else
		{
			int x;
			cin >> x;
			if(x == 0)cout << tr[1].sum0 << ' ';
			else cout << tr[1].sum1 << ' ';
		}
	}
	cout << endl;
}

int main()
{
	IOS
	int _;
	cin >> _;
	while(_ --)
	{
		solve();
	}
	
	return 0;
}

Node节点存两个值sum0和sum1,f作为懒标记。

F

i在要a[i]之前被卖出,其实就是拓扑排序,先输出没在环中的点,然后每个环中,值最小的那个点最后卖出一定是最优的,类似贪心。

其实我在想如果一个点同时出现在两个环中该怎么办,然后发现这种情况其实不存在

比如

Codeforces Round 895 (Div. 3) A ~ F,cf,算法,c++,数据结构

如果一个点出现在多个环中,边数会比点数还多,因为又要求每个点的出度都为1,所以这种情况显然是与输入要求矛盾的,所以一个点一定最多出现在一个环内,证毕。文章来源地址https://www.toymoban.com/news/detail-712562.html

#include<bits/stdc++.h>
#define IOS ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'

using namespace std;

typedef pair<int, int> PII;
typedef long long ll;

const int N = 100010;

int n;
int h[N], e[N], ne[N], idx;
int d[N];
int a[N], b[N];
bool st[N];
vector<int> ans;
queue<int> q;

void add(int a, int b)
{
	e[idx] = b, ne[idx] = h[a], h[a] = idx ++;
}

void bfs()
{
	while(q.size())
	{
		int t = q.front();
		q.pop();
		ans.push_back(t);
		
		for(int i = h[t]; i != -1; i = ne[i])
		{
			int j = e[i];
			if(st[j])continue;
			d[j] --;
			if(!d[j])
			{
				q.push(j);
				st[j] = true;
			}
		}
	}
}

void solve()
{
	idx = 0;
	ans.clear();
	cin >> n;
	priority_queue<PII, vector<PII>, greater<PII>> heap;
	for(int i = 1; i <= n; i ++)d[i] = 0;
	for(int i = 1; i <= n; i ++)
	{
		st[i] = false;
		h[i] = -1;
		cin >> a[i];
		add(i, a[i]);
		d[a[i]] ++;
	}
	for(int i = 1; i <= n; i ++)
	{
		cin >> b[i];
		heap.push({b[i], i});
		if(!d[i])
		{
			st[i] = true;
			q.push(i);
		}
	}

	bfs();

	while(ans.size() < n)
	{
		int ver;
		while(heap.size())
		{
			PII t = heap.top();
			heap.pop();
			if(!st[t.second])
			{
				ver = t.second;
				break;
			}
		}

		st[ver] = true;
		for(int i = h[ver]; i != -1; i = ne[i])
		{
			int j = e[i];
			if(st[j])continue;
			d[j] --;
			if(!d[j])
			{
				q.push(j);
				st[j] = true;
			}
		}
		bfs();
		ans.push_back(ver);
	}
	
	for(int i = 0; i < n; i ++)cout << ans[i] << ' ';
	cout << endl;
	
}

int main()
{
	IOS
	int _;
	cin >> _;
	while(_ --)
	{
		solve();
	}
	
	return 0;
}

到了这里,关于Codeforces Round 895 (Div. 3) A ~ F的文章就介绍完了。如果您还想了解更多内容,请在右上角搜索TOY模板网以前的文章或继续浏览下面的相关文章,希望大家以后多多支持TOY模板网!

本文来自互联网用户投稿,该文观点仅代表作者本人,不代表本站立场。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如若转载,请注明出处: 如若内容造成侵权/违法违规/事实不符,请点击违法举报进行投诉反馈,一经查实,立即删除!

领支付宝红包 赞助服务器费用

相关文章

  • Codeforces Round 874 (Div. 3)

    用最少的长度为2的字符串按一定规则拼出s。规则是:前一个字符串的尾与后一个字符串的首相同。 统计s中长度为2的不同字符串数量。 给定数组a[n]和b[n],重排b后,令任意|ai−bi|≤k成立(1≤k≤n)数据保证一定有解。 将a和b分别按从小到大的顺序匹配便是最优的,一定能满足

    2024年02月05日
    浏览(36)
  • Codeforces Round 868 Div 2

    要求构造一个仅包含 (1) 和 (-1) 的长度为 (n) 的数组 (a) ,使得存在 (k) 个下标对 ((i, j), i j) 满足 (a_i times a_j = 1) 。 当有 (x) 个 (1) , (y) 个 (-1) 时,其满足条件的下标对数量为 (frac{x (x - 1)}{2} + frac{y (y - 1)}{2}) 。 由于 (n) 只有 (100) ,直接枚举 (x) 即可。

    2024年02月01日
    浏览(43)
  • Codeforces Round 871 (Div. 4)

    给定n个长度为10的字符串,问其与codeforces字符串的对应下标字母不同的个数。 对于每个字符串从前往后依次和“codeforces”对应字符比较然后统计不同字母数即可 给定长度为n的数组,问连续相邻为0的最大长度 维护一个全局最大长度res,和当前连续序列的长度cnt。从前往后扫

    2024年02月03日
    浏览(51)
  • Codeforces Round 867 (Div. 3)

    从所有a[i]+i-1=t的选择种取个max即可 实际上就是取同符号乘积的最大值 找规律,发现结果与边长n的关系是:res = n * (n + 3) - (n - 2) ①当n为奇数时,除了1其他均无解 ②当n为偶数时,我们可以构造一个形如n,1,n - 2,3,...的数列 首先我们可以发现n必定出现在起始位置。如果n不在起

    2024年02月02日
    浏览(45)
  • Codeforces Round 881 (Div. 3)

    给定一个数组,给每个元素涂色。求最大的代价。 代价为每个颜色的代价和。 每个颜色的代价为涂了该颜色的元素的极差。 因为是极差,每个元素要么对答案有正的贡献,要么有负的贡献,要么无贡献。且正负贡献的个数要相同。 因为要最大值,自然就是想有正贡献的是最

    2024年02月09日
    浏览(41)
  • Codeforces Round 912 (Div. 2)

    大等于2依据冒泡排序即可排序,因此判断下1即可 对每一个数字找哪一位肯定为0填0其他的填1 从后往前考虑加到当前集合或新立一个集合 从最高位开始考虑能否为1,计算能否时每个数当前位为1

    2024年02月04日
    浏览(43)
  • Codeforces Round 882 (Div. 2)

    目录 A. The Man who became a God  题目分析: B. Hamon Odyssey 题目分析: C. Vampiric Powers, anyone? 题目分析:  n个人分成k组,每一组的力量都是 这样的,那么如果分成k组那么就会有k-1个力量不被统计,将力量总和减去前k-1个最大的力量就是最小的结果   将数组分组,每个组内进行按位与

    2024年02月05日
    浏览(48)
  • Codeforces Round 894 (Div. 3)

    签到题 a数组里,大于等于前一个值的a[i]会被写到b里。直接遍历b,如果b[i]比前一个小就在它前面插一个相等的值 计算反过来的长度,判断是否相等就行 对于没有重复口味的集合,能选出的方案是n*(n-1)/2 (从n个里面选2个的组合数)。二分找出需要多少不同口味的冰淇淋,

    2024年02月11日
    浏览(43)
  • Codeforces Round 877 (Div. 2) 题解

    写了两题了,先总结一下吧。。。看了三题,都是思维题构造题,搞心态真的搞心态。。。感觉自己屁都不会,完全没有动力。。。有的有思路但是写不出来,但是思路不够成熟,练的题太少,其实这场到B题就卡住了,C题也是,题意都能读懂,但是思考的方向不对,很焦虑

    2024年02月10日
    浏览(39)
  • Codeforces Round 889 (Div. 2) 题解

    晚上睡不着就来总结一下叭~(OoO) 终榜!!! 先不放图了。。怕被dalaoHack...呜呜呜~         7.29半夜比赛,本来是不想打的,感觉最近做的题太多了,什么牛客杭电以及CF上的题等等等,挺杂的,也来不及整理,本想梳理一下,而且也感觉今天状态不太好,但见他们都要

    2024年02月15日
    浏览(46)

觉得文章有用就打赏一下文章作者

支付宝扫一扫打赏

博客赞助

微信扫一扫打赏

请作者喝杯咖啡吧~博客赞助

支付宝扫一扫领取红包,优惠每天领

二维码1

领取红包

二维码2

领红包